<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Cuti API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Cuti</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/jenis_cuti/index" class="list-group-item list-group-item-action ">Jenis Cuti</a>
                    <a href="/jenis_karyawan/index" class="list-group-item list-group-item-action ">Jenis Karyawan</a>
                    <a href="/karyawan/index" class="list-group-item list-group-item-action">Karyawan</a>
                    <a href="/status/index" class="list-group-item list-group-item-action">Status</a>
                    <a href="/cuti/index" class="list-group-item list-group-item-action active">Cuti</a>
                    <a href="/cuti_approval/index" class="list-group-item list-group-item-action">Cuti Approval</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2> Cuti API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchCuti(this.value)" autocomplete="off">
                        <div id="cutiList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList() {
            $.ajax({
                url: '/api/cuti',
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    $.ajax({
                        url: '/api/cuti_approval',
                        type: 'get',
                        contentType: 'application/json',
                        success: function(dataApprov) {
                            var table = '<table class="table table-hover">';

                            table += "<tr>";
                            table += "<th> # </th>";
                            table += "<th> ID Cuti </th>";
                            table += "<th> Tanggal Mulai </th>";
                            table += "<th> Tanggal Akhir</th>";
                            table += "<th> Lama Cuti </th>";
                            table += "<th> Status</th>";
                            table += "<th> Action</th>";
                            table += "</tr>";

                            for (let i = 0; i < data.length; i++) {
                                table += "<tr>";
                                table += "<td>" + (i + 1) + "</td>";
                                table += "<td>" + data[i].id + "</td>";
                                table += "<td>" + data[i].tanggalAwal + "</td>";
                                table += "<td>" + data[i].tanggalAkhir + "</td>";
                                table += "<td>" + data[i].lamaCuti + ' Hari' + "</td>";
                                table += "<td>" + data[i].status.status + "</td>";
                                table += "<td><button class='btn btn-success' value='" + data[i].id + "' onclick='formEdit(this.value)'>Update</button> " + ' '
                                table += "<button class='btn btn-danger' value='" + data[i].id + "' onclick='formDelete(this.value)'>Delete</button></td>";
                                table += "</tr>"

                            }
                            table += "</table>";
                            $('#cutiList').html(table);
                        }

                    });
                }

            });
        }

        function OpenForm() {
            $.ajax({
                url: '/api/jenis_cuti',
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered"';
                    form += "<tr>";
                    form += "<td>Jenis Cuti</td>";
                    form += "<td><select class='custom-select' id='jenis_cuti_id'>";
                    for (let i = 0; i < data.length; i++) {
                        form += "<option value='" + data[i].id + "'>" + data[i].nama + "</option>";
                    }
                    form += "</select></td>";
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Tanggal Mulai</td>";
                    form += '<td><input class="form-control" type ="date" id="tanggal_mulai"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Tanggal Akhir</td>";
                    form += '<td><input class="form-control" type ="date" id="tanggal_akhir" onChange="hitung()"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Lama Cuti</td>";
                    form += '<td id="lamaCuti"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveCuti(this.value)">Save</button></td>';
                    form += '</tr>';
                    $("#cutiList").html(form);
                }
            });
        }


        function SaveCuti() {
            var formData = '{';
            formData += '"jenisCutiId":"' + $('#jenis_cuti_id').val() + '",';
            formData += '"tanggalAwal":"' + $('#tanggal_mulai').val() + '",';
            formData += '"tanggalAkhir":"' + $('#tanggal_akhir').val() + '",';
            formData += '"lamaCuti":"' + $('#lama').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/cuti',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/cuti/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/jenis_cuti/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataJenisCuti) {
                            form += "<tr>";
                            form += "<td>Jenis Cuti </td>"
                            form += "<td><select class='custom-select' id='jenis_cuti_id'>"
                            for (let i = 0; i < dataJenisCuti.length; i++) {
                                if (dataJenisCuti[i].id == data.jenisCutiId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataJenisCuti[i].id + "' " + selected + ">" + dataJenisCuti[i].nama + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<td>Tanggal Mulai</td>";
                            form += "<td><input class='form-control' type='date' id='tanggal_mulai' value='" + data.tanggalAwal + "'><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Tanggal Akhir</td>";
                            form += "<td><input class='form-control' type='date' id='tanggal_akhir' onChange='hitung()' value='" + data.tanggalAkhir + "'><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "' ></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Lama Cuti</td>";
                            form += "<td id='lamaCuti' value='" + data.lamaCuti + "'></td>";
                            form += "</tr>";
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateCuti(this.value)">Save</button></td>';
                            form += '</tr>';
                            $('#cutiList').html(form);
                        }
                    });
                }
            });
        }

        function UpdateCuti(id) {
            var formData = '{';
            formData += '"jenisCutiId":"' + $('#jenis_cuti_id').val() + '",';
            formData += '"tanggalAwal":"' + $('#tanggal_mulai').val() + '",';
            formData += '"tanggalAkhir":"' + $('#tanggal_akhir').val() + '",';
            formData += '"lamaCuti":"' + $('#lama').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/cuti/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/cuti/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/jenis_cuti/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataJenisCuti) {
                            form += "<tr>";
                            form += "<td>Jenis Cuti </td>"
                            form += "<td><select class='custom-select' id='jenis_cuti_id' disabled>"
                            for (let i = 0; i < dataJenisCuti.length; i++) {
                                if (dataJenisCuti[i].id == data.jenisCutiId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataJenisCuti[i].id + "' " + selected + ">" + dataJenisCuti[i].nama + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<td>Tanggal Mulai</td>";
                            form += "<td><input class='form-control' type='date' id='tanggal_mulai' value='" + data.tanggalAwal + "' disabled><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Tanggal Akhir</td>";
                            form += "<td><input class='form-control' type='date' id='tanggal_akhir' onChange='hitung()' value='" + data.tanggalAkhir + "' disabled><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "' ></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Lama Cuti</td>";
                            form += "<td><input class='form-control' type='text' id='lama' value='" + data.lamaCuti + "' disabled>";
                            form += "</tr>";
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-danger" value="' + data.id + '" onclick="DeleteCuti(this.value)">Delete</button></td>';
                            form += '</tr>';
                            $('#cutiList').html(form);
                        }
                    });
                }
            });
        }

        function DeleteCuti(id) {
            var formData = '{';
            formData += '"jenisCutiId":"' + $('#jenis_cuti_id').val() + '",';
            formData += '"tanggalAwal":"' + $('#tanggal_mulai').val() + '",';
            formData += '"tanggalAkhir":"' + $('#tanggal_akhir').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/cuti/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        let jumlah = 0;

        function hitung() {
            hideAll();
            let awal = new Date(document.getElementById("tanggal_mulai").value);
            let akhir = new Date(document.getElementById("tanggal_akhir").value);
            let selisih = new Date(akhir.getTime() - awal.getTime());
            jumlah = (selisih / (1000 * 3600 * 24));
            $('#lamaCuti').append("<input class='form-control' type='text' id='lama' value='" + jumlah + "'>");
        }

        function hideAll() {
            $('#lamaCuti').empty();
        }
    </script>